from _typeshed import Incomplete
from google.rpc.error_details_pb2 import ErrorInfo as ErrorInfo
from pyspark.errors.exceptions.base import AnalysisException as BaseAnalysisException, ArithmeticException as BaseArithmeticException, ArrayIndexOutOfBoundsException as BaseArrayIndexOutOfBoundsException, DateTimeException as BaseDateTimeException, IllegalArgumentException as BaseIllegalArgumentException, NumberFormatException as BaseNumberFormatException, ParseException as BaseParseException, PySparkException as PySparkException, PythonException as BasePythonException, QueryExecutionException as BaseQueryExecutionException, SparkRuntimeException as BaseSparkRuntimeException, SparkUpgradeException as BaseSparkUpgradeException, StreamingQueryException as BaseStreamingQueryException, UnsupportedOperationException as BaseUnsupportedOperationException

class SparkConnectException(PySparkException): ...

def convert_exception(info: ErrorInfo, message: str) -> SparkConnectException: ...

class SparkConnectGrpcException(SparkConnectException):
    message: Incomplete
    def __init__(self, message: str | None = None, error_class: str | None = None, message_parameters: dict[str, str] | None = None, reason: str | None = None) -> None: ...

class AnalysisException(SparkConnectGrpcException, BaseAnalysisException): ...
class ParseException(AnalysisException, BaseParseException): ...
class IllegalArgumentException(SparkConnectGrpcException, BaseIllegalArgumentException): ...
class StreamingQueryException(SparkConnectGrpcException, BaseStreamingQueryException): ...
class QueryExecutionException(SparkConnectGrpcException, BaseQueryExecutionException): ...
class PythonException(SparkConnectGrpcException, BasePythonException): ...
class ArithmeticException(SparkConnectGrpcException, BaseArithmeticException): ...
class UnsupportedOperationException(SparkConnectGrpcException, BaseUnsupportedOperationException): ...
class ArrayIndexOutOfBoundsException(SparkConnectGrpcException, BaseArrayIndexOutOfBoundsException): ...
class DateTimeException(SparkConnectGrpcException, BaseDateTimeException): ...
class NumberFormatException(IllegalArgumentException, BaseNumberFormatException): ...
class SparkRuntimeException(SparkConnectGrpcException, BaseSparkRuntimeException): ...
class SparkUpgradeException(SparkConnectGrpcException, BaseSparkUpgradeException): ...
