from _typeshed import Incomplete
from pyspark.errors import PySparkRuntimeError as PySparkRuntimeError
from pyspark.java_gateway import local_connect_and_auth as local_connect_and_auth
from pyspark.resource import ResourceInformation as ResourceInformation
from pyspark.serializers import UTF8Deserializer as UTF8Deserializer, read_int as read_int, write_int as write_int, write_with_length as write_with_length

class TaskContext:
    def __new__(cls) -> TaskContext: ...
    @classmethod
    def get(cls) -> TaskContext | None: ...
    def stageId(self) -> int: ...
    def partitionId(self) -> int: ...
    def attemptNumber(self) -> int: ...
    def taskAttemptId(self) -> int: ...
    def getLocalProperty(self, key: str) -> str | None: ...
    def cpus(self) -> int: ...
    def resources(self) -> dict[str, ResourceInformation]: ...

BARRIER_FUNCTION: int
ALL_GATHER_FUNCTION: int

class BarrierTaskContext(TaskContext):
    @classmethod
    def get(cls) -> BarrierTaskContext: ...
    def barrier(self) -> None: ...
    def allGather(self, message: str = '') -> list[str]: ...
    def getTaskInfos(self) -> list['BarrierTaskInfo']: ...

class BarrierTaskInfo:
    address: Incomplete
    def __init__(self, address: str) -> None: ...
